% FLENG compiler - toplevel

:- dynamic([pdef/2, r_atom/2, r_data/1, module_name/1, module_init/1]).
:- dynamic([no_warnings/0, debug_info/0, entry_point/2, uses/1]).
:- dynamic([drop_sequence/3, literal/2, symbol_loc/2]).
:- dynamic([pdef_name/2, module_info/3]).
:- initialization(main).

:- if(current_prolog_flag(prolog_name, 'GNU Prolog')).
:- include('version.pl').
:- include('compiler.pl').
:- include('index.pl').
:- include('lfa.pl').
:- include('asm.pl').
main :-
    argument_list(Args),
    main(Args).
:- else.
% SWI
:- include(fleng('version.pl')).
:- include(fleng('compiler.pl')).
:- include(fleng('index.pl')).
:- include(fleng('lfa.pl')).
:- include(fleng('asm.pl')).
format_to_atom(Out, Fstr, Args) :-
    format_to_codes(Fstr, Args, S),
    atom_codes(Out, S).
g_assign(Var, Val) :- nb_setval(Var, Val).
g_read(Var, Val) :- nb_getval(Var, Val).
:- endif.
